{-# LANGUAGE RankNTypes, FlexibleContexts #-}
module ULogin 
 (  
      login
 )
where


import API
import Spwd

import SecLib.Untrustworthy 
import SecLib.LatticeLH

login :: Screen L 
         -> (Sec H (String, Cypher) -> SecIO L (Sec L Bool))
         -> SecIO L ()
login scr eh
   = do putStrLnSecIO scr "Welcome!"
        putStrSecIO scr "login:"
        user <- getLineSecIO scr
        spwd <- getSpwdName user
        case spwd of 
             Nothing    -> putStrLnSecIO scr "Invalid user!"
             Just spwd  -> do b <- verify 3 spwd scr eh
                              if b then putStrLnSecIO scr "Launching shell!"
                                   else error "Access denied!"

verify 0 _ scr _ = do putStrLnSecIO scr "Maximum number of tries reached!"
                      return False
verify (n+1) spwd scr eh = do putStrLnSecIO scr "password:"
                              p <- getLineSecIO scr 
                              sec_l <- eh (do c <- cypher spwd
                                              return (p,c) )
                              let result = public sec_l 
                              if result then return True 
                                        else do putStrLnSecIO scr "Invalid login!" 
                                                verify n spwd scr eh
                       
      